/*  Copyright (C) 2015 Zoltán Nagy
 *  Created by Zoltán Nagy on 3/28/15.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/*   std includes   */

/*   project headers  */
#include "cont-tree-iterator.h"


namespace duct {
  namespace container {

  
  
    std::string topology(const __tree_node_link * xc)
    {
      /* if the tree is empty, do nothing   */
      if(xc == nullptr) return {"[N]"};
      
      const __tree_node_link *root = xc->up;
      
      /*   the head   */
      std::string ret{"[H"};
      
      while(xc != root) {
        /*   writing the instruction into a string   */
        if(xc->left) {
          xc = xc->left;
          ret += (xc ? "L" : "N");
        }
        else if(xc->right) {
          xc = xc->right;
          ret += (xc ? "R" : "N");
        }
        else {
          while(xc->up != root && (xc->up->right == xc || xc->up->right == nullptr)) {
            xc = xc->up;
            ret += "u";
          }
          
          if(xc->up != root) {
            xc = xc->up->right;
            ret += (xc ? "uR" : "uN");
          } else {
            ret += "N";
            break;
          }
        }
      }
      ret += "]";
      
      return ret;
    }
    
    
    
    
  }
}

