/*  Copyright © 2016 Zoltán Nagy. All rights reserved.
 *  Created by Zoltán Nagy on 29/08/16.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __mc_engine_opts_h__
#define __mc_engine_opts_h__ 1


/*   std includes   */

/*   project headers   */
#include <bits/duct-tags.h>



namespace duct {
  
 
  /*   Simple structure to provide input parameters for the shower engine.   */
  struct shower_engine_opts
  {
    /*   cutoff kT scale   */
    double kT_cutoff = 1.0_GeV;
    
    /*   max allowed color suppression   */
    unsigned max_color_suppression = 0u;
    
    /*   allow color branching on the the history tree   */
    bool allow_color_branching = true;

    
    /*   calculate threshold weight   */
    struct threshold_opts {
      /*   enable or disable threshold weights   */
      bool enabled = true;
    } threshold;
  };
  
  
  
}

#endif
