/*  Copyright (C) 2014 Zoltán Nagy
 *  Created by Zoltán Nagy on 11/23/14.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __mc_ordering_h__
#define __mc_ordering_h__ 1

/*   std includes   */

/*   project headers   */
#include <bits/duct-tags.h>
#include <bits/duct-lorentzvector.h>
#include <bits/mc-hard-params.h>
#include <bits/duct-mapping.h>



namespace duct {
  
  

  /*   Defining the ordering dependent functions.
   *   This is the class that we have to specialize.
   *   It has to describe both the massless and massive evolution.
   */
  template<class _Tag, class _Ordering>
  struct ordering_traits;
  
}


/*   Specialization for various orderings.   */
#include <bits/mc-ordering-lmd.h>
#include <bits/mc-ordering-kT.h>
#include <bits/mc-ordering-angle.h>


#endif
